<?php
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

//*****************************
// Start session management
//*****************************
$user->session_begin();
$auth->acl($user->data);
$user->setup('viewtopicviewers');

//*****************************
// Get and set some variables
//*****************************
$topic	= request_var('topic', 0);
$supp	= request_var('delete', 0);

if(!$config['tv_enable'])
{
	trigger_error('TV_DISABLED');
}

//*****************************
// Do you want to delete statistics for this topic ?
//*****************************
if($supp==1)
{
	//Admin ? go to confirm box
	if($auth->acl_get('a_'))
	{
		$s_hidden_fields = build_hidden_fields(array(
			'f'		=> $forum_id)
		);

		if (confirm_box(true))
		{
			//Delete
				$sql = 'DELETE FROM ' . TOPICS_VIEWERS_TABLE . "
						WHERE topic_id = $topic";
				$result = $db->sql_query($sql);
			
			//Display
			$meta_info = append_sid("{$phpbb_root_path}viewtopicviewers.$phpEx", 'topic=' . $topic);
			
			$message = $user->lang['TV_STATS_DELETED'] . '<br/><br/>';
			$message .= sprintf($user->lang['TV_RETURN_STATS'], '<a href="' . $meta_info . '">', '</a>');

			meta_refresh(3, $meta_info);
			trigger_error($message);
		}
		else
		{
			confirm_box(false, 'TV_DELETE_STATISTICS', $s_hidden_fields);
		}
	}
	else
		trigger_error('NO_AUTH_OPERATION');
}

//*****************************
// Check if the topic exist
//*****************************
	$sql = 'SELECT forum_id
		FROM ' . TOPICS_TABLE . "
		WHERE topic_id = $topic";
	$result = $db->sql_query($sql);
	$forum_id = (int) $db->sql_fetchfield('forum_id');
	$db->sql_freeresult($result);

	if (!$forum_id)
	{
		trigger_error('NO_TOPIC');
	}

//*****************************
// Get user list
//*****************************
	$sql = 'SELECT u.user_id, u.username, u.username_clean, u.user_type, u.user_colour, v.user_id, COUNT(v.user_id) AS nb, MAX(v.date) as date
		FROM ' . USERS_TABLE . ' u, ' . TOPICS_VIEWERS_TABLE . ' v
		WHERE u.user_id = v.user_id
			AND v.topic_id = ' . $topic . '
		GROUP BY v.user_id
		ORDER BY u.username_clean';
	$result = $db->sql_query($sql);

	$prev_id = $prev_ip = $user_list = array();

	$total = 0;

	while ($row = $db->sql_fetchrow($result))
	{
		if ($row['user_id'] != ANONYMOUS && !isset($prev_id[$row['user_id']]))
		{
			//User color
			$user_colour = ($row['user_colour']) ? ' style="color:#' . $row['user_colour'] . '" class="username-coloured"' : '';
			//How username is display
			$username_full = ($row['user_type'] != USER_IGNORE) ? get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']) . ', ' : '<span' . $user_colour . '>' . $row['username'] . '</span>, ';
			//Last view
			$dates = $user->format_date($row['date']);
			
			$prev_id[$row['user_id']] = 1;			
			$total++;
			
			//Is there a post from this user in this topic ?
				$sql_posts = 'SELECT COUNT(post_id) as nb_post
								FROM ' . POSTS_TABLE . '
								WHERE poster_id = ' . $row['user_id'] . '
									AND topic_id = ' . $topic;
				$result_posts = $db->sql_query($sql_posts);
				$post = (int) $db->sql_fetchfield('nb_post');
				$db->sql_freeresult($result_posts);
				
			if($post>0)
			{
				$postimage="topicyes.gif";
				$postalt=$user->lang['TV_POST'];
			}
			else
			{
				$postimage="topicno.gif";
				$postalt=$user->lang['TV_NOPOST'];
			}
			
			// Send vars to template
			$template->assign_block_vars('user_row', array(
					'USERNAME_FULL'	=> substr($username_full, 0, -2),
					'DATES'			=> $dates,
					'NB'			=> $row['nb'],
					'POSTER'		=> "<img src=\"" . $phpbb_root_path . "styles/" . $user->theme['theme_path'] . "/theme/images/$postimage\" alt=\"$postalt\" />",
			));	
		}
	}
	
	$template->assign_vars(array(
			'TOTAL_TOPIC_VIEWERS'	=> sprintf($user->lang['TV_TOTAL_VIEWERS'], $total)
	));
	
	$db->sql_freeresult($result);
	unset($prev_id, $prev_ip);
	
//*****************************
// Grab group details for legend display
//*****************************
	if ($auth->acl_gets('a_group', 'a_groupadd', 'a_groupdel'))
	{
		$sql = 'SELECT group_id, group_name, group_colour, group_type
			FROM ' . GROUPS_TABLE . '
			WHERE group_legend = 1
			ORDER BY group_name ASC';
	}
	else
	{
		$sql = 'SELECT g.group_id, g.group_name, g.group_colour, g.group_type
			FROM ' . GROUPS_TABLE . ' g
			LEFT JOIN ' . USER_GROUP_TABLE . ' ug
				ON (
					g.group_id = ug.group_id
					AND ug.user_id = ' . $user->data['user_id'] . '
					AND ug.user_pending = 0
				)
			WHERE g.group_legend = 1
				AND (g.group_type <> ' . GROUP_HIDDEN . ' OR ug.user_id = ' . $user->data['user_id'] . ')
			ORDER BY g.group_name ASC';
	}
	$result = $db->sql_query($sql);

	$legend = '';
	while ($row = $db->sql_fetchrow($result))
	{
		if ($row['group_name'] == 'BOTS')
		{
			$legend .= (($legend != '') ? ', ' : '') . '<span style="color:#' . $row['group_colour'] . '">' . $user->lang['G_BOTS'] . '</span>';
		}
		else
		{
			$legend .= (($legend != '') ? ', ' : '') . '<a style="color:#' . $row['group_colour'] . '" href="' . append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=group&amp;g=' . $row['group_id']) . '">' . (($row['group_type'] == GROUP_SPECIAL) ? $user->lang['G_' . $row['group_name']] : $row['group_name']) . '</a>';
		}
	}
	$db->sql_freeresult($result);
	
	
//*****************************
// Statistics
//*****************************
	//What time is it ?
	$now = time();
	
	//Get total views and start time for this topic
	$sql_infos = 'SELECT COUNT(topic_id) as total
					FROM ' . TOPICS_VIEWERS_TABLE . '
					WHERE topic_id = ' . $topic . '
					GROUP BY topic_id';
	$result_infos = $db->sql_query($sql_infos);
		$total_viewers 	= (int) $db->sql_fetchfield('total');
	$db->sql_freeresult($result_infos);
	
	$sql_infos = 'SELECT MIN(date) as date
					FROM ' . TOPICS_VIEWERS_TABLE . '
					WHERE topic_id = ' . $topic . '
					GROUP BY topic_id';
	$result_infos = $db->sql_query($sql_infos);
		$start_time 	= (int) $db->sql_fetchfield('date');
	$db->sql_freeresult($result_infos);
			
	if($total_viewers>0)
	{
		//Lets go...
		$current = $start_time;
		
		while($current < $now)
		{
			$next = mktime(0,0,0,intval(date("n",$current))+1,1,intval(date("Y",$current)));
			
			$sql_nb = 'SELECT COUNT(date) as nb
							FROM ' . TOPICS_VIEWERS_TABLE . '
							WHERE topic_id = ' . $topic . '
								AND date >= ' . $current . ' AND date < ' . $next ;
			$result_nb = $db->sql_query($sql_nb);
				$nb	= (int) $db->sql_fetchfield('nb');
			$db->sql_freeresult($result_nb);
			
			
			// Send vars to template
			$template->assign_block_vars('stats', array(
					'MONTH'		=> $user->format_date($current, "F Y"),
					'PCT'		=> round($nb/$total_viewers*100),
					'PERCENT'	=> round($nb/$total_viewers*100,2) . '%',
					'RESULT'	=> $nb
			));	

			$current = $next;
		}
	}

	

//*****************************
// Refreshing the page every 60 seconds...
//*****************************
	meta_refresh(60, append_sid("{$phpbb_root_path}viewtopicviewers.$phpEx", "topic=$topic"));

	
// Send data to template
	$template->assign_vars(array(
		'LEGEND'	=> $legend
	));
	
	
//*****************************
// Can the user delete statistics ?
//*****************************
	if($auth->acl_get('a_'))
	{
		$template->assign_vars(array(
		'U_SUPP'	=> "<a href=\"". append_sid("{$phpbb_root_path}viewtopicviewers.$phpEx", "topic=$topic&amp;delete=1") ."\">". $user->lang['TV_DELETE_STATISTICS'] ."</a>"
	));
	}

//*****************************
// Output the page
//*****************************
	page_header($user->lang['VIEW_TOPIC_VIEWERS']);

	$template->set_filenames(array(
		'body' => 'viewtopicviewers_body.html')
	);
	
make_jumpbox(append_sid("{$phpbb_root_path}viewforum.$phpEx"));

page_footer();

?>